#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_GiftRewardCFG.h"
std::auto_ptr<M_GiftRewardCFG> M_GiftRewardCFG::msSingleton(nullptr);

int M_GiftRewardCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_GiftRewardCFGData* M_GiftRewardCFG::GetData(int RewardType)
{
	auto it = mMapData.find(RewardType);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_GiftRewardCFGData>& M_GiftRewardCFG::GetMapData()
{
	return mMapData;
}

void M_GiftRewardCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_GiftRewardCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_GiftRewardCFGData data;
		data.mRewardType = element->IntAttribute("RewardType");
		data.mStartTime = element->Attribute("StartTime");
		data.mEndTime = element->Attribute("EndTime");
		{
			const char* ItemId = element->Attribute("ItemId");
			std::vector<std::string> vecItemId;
			boost::split(vecItemId, ItemId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemId[i].c_str(), &temp))
				{
					data.mItemId.push_back(temp);
				}
			}
		}
		{
			const char* ItemCount = element->Attribute("ItemCount");
			std::vector<std::string> vecItemCount;
			boost::split(vecItemCount, ItemCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemCount[i].c_str(), &temp))
				{
					data.mItemCount.push_back(temp);
				}
			}
		}
		{
			const char* ItemId2 = element->Attribute("ItemId2");
			std::vector<std::string> vecItemId2;
			boost::split(vecItemId2, ItemId2, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemId2.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemId2[i].c_str(), &temp))
				{
					data.mItemId2.push_back(temp);
				}
			}
		}
		{
			const char* ItemId3 = element->Attribute("ItemId3");
			std::vector<std::string> vecItemId3;
			boost::split(vecItemId3, ItemId3, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemId3.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemId3[i].c_str(), &temp))
				{
					data.mItemId3.push_back(temp);
				}
			}
		}
		data.mPrice = element->IntAttribute("Price");
		{
			const char* TotalPrice = element->Attribute("TotalPrice");
			std::vector<std::string> vecTotalPrice;
			boost::split(vecTotalPrice, TotalPrice, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecTotalPrice.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecTotalPrice[i].c_str(), &temp))
				{
					data.mTotalPrice.push_back(temp);
				}
			}
		}
		data.mVipLevel = element->IntAttribute("VipLevel");
		data.mGiftId = element->IntAttribute("GiftId");
		if (mMapData.find(data.mRewardType) != mMapData.end())std::cout <<"data refind:" << data.mRewardType << std::endl;
		CCASSERT(mMapData.find(data.mRewardType) == mMapData.end(), "data.mRewardType is exists");
		mMapData.insert(std::make_pair(data.mRewardType, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_GiftRewardCFG Loaded. Load Data:%u", mMapData.size());
}

void M_GiftRewardCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_GiftRewardCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_GiftRewardCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_GiftRewardCFGData data;
		LuaCfgHelper::readInt(L, "RewardType", data.mRewardType);
		LuaCfgHelper::readString(L, "StartTime", data.mStartTime);
		LuaCfgHelper::readString(L, "EndTime", data.mEndTime);
		LuaCfgHelper::readVectorInt(L, "ItemId", data.mItemId);
		LuaCfgHelper::readVectorInt(L, "ItemCount", data.mItemCount);
		LuaCfgHelper::readVectorInt(L, "ItemId2", data.mItemId2);
		LuaCfgHelper::readVectorInt(L, "ItemId3", data.mItemId3);
		LuaCfgHelper::readInt(L, "Price", data.mPrice);
		LuaCfgHelper::readVectorInt(L, "TotalPrice", data.mTotalPrice);
		LuaCfgHelper::readInt(L, "VipLevel", data.mVipLevel);
		LuaCfgHelper::readInt(L, "GiftId", data.mGiftId);
		if (mMapData.find(data.mRewardType) != mMapData.end())std::cout <<"data refind:" << data.mRewardType << std::endl;
		CCASSERT(mMapData.find(data.mRewardType) == mMapData.end(), "data.mRewardType is exists");
		mMapData.insert(std::make_pair(data.mRewardType, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_GiftRewardCFG Loaded. Load Data:%u", mMapData.size());
}

void M_GiftRewardCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_GiftRewardCFG* M_GiftRewardCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_GiftRewardCFG());
	}
	return msSingleton.get();
}

void M_GiftRewardCFG::Release()
{
	msSingleton.reset(nullptr);
}
